//---------------------------------------------------------------------------
//  MS wq䴩 codepage Φb HTML  CHARSET NӪ
//    <META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=windows-1251">
//    http://msdn.microsoft.com/library/default.asp?url=/workshop/author/dhtml/reference/charsets/charset4.asp
//  Xù Konstantin Kazarnovsky  CP_nnnn.nls P C_nnnn.cls ɪeѪR
//    http://webcenter.ru/~kazarn/eng/nls.htm
//  H  Kii Ali Ҿzu޳N_NT nls Dv
//    http://ftp.isu.edu.tw/pub/CPatch/faq/tech/tech_nlsnt.txt
//  MS pۤv[J codepage
//    http://msdn.microsoft.com/library/default.asp?url=/library/en-us/vcce/htm/evc_appendices_1.asp
//    http://support.microsoft.com/default.aspx?scid=kb;EN-US;151701
//  SANJYSAN b KTOP ҴѪuUXơv
//    http://delphi.ktop.com.tw/topic.asp?TOPIC_ID=55094
// <2004-10-09> z by Lee, Dong-Liang <dllee [at] edirect168.com>
//              http://dllee.ktop.com.tw
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "CodePageUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TStringList *CodePageListSupported;
TStringList *CodePageList;
CPINFOEX CodePageInfoEx;
BOOL CALLBACK EnumCodePagesProc(LPTSTR lpCodePageString)   // code page identifier string
{
  UINT CodePage=String(lpCodePageString).ToIntDef(0);
  if(IsValidCodePage(CodePage))   // code page
  {
    GetCPInfoEx(CodePage,0,&CodePageInfoEx);
    CodePageList->AddObject(CodePageInfoEx.CodePageName,(TObject*)CodePage);
    CodePageListSupported->AddObject(CodePageInfoEx.CodePageName,(TObject*)CodePage);
  }
  else
  {
    CodePageList->AddObject(String(lpCodePageString)+" **Not Installed**",
      (TObject*)CodePage);
  }
  return true;
}
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  CodePageList=new TStringList;
  CodePageListSupported=new TStringList;
  EnumSystemCodePages((CODEPAGE_ENUMPROC)EnumCodePagesProc, // callback function
    CP_SUPPORTED);  // CP_INSTALLED: installed, CP_SUPPORTED: supported code pages
  Memo1->Lines->Add("This System Support All the following CodePage.");
  Memo1->Lines->Add("If the name of the CodePage is **Not Installed** means it is not installed.");
  Memo1->Lines->AddStrings(CodePageList);
  ComboBox1->Items->AddStrings(CodePageListSupported);
  ComboBox2->Items->AddStrings(CodePageListSupported);
  ComboBox1->ItemIndex=ComboBox1->Items->IndexOfObject((TObject*)950);
  ComboBox2->ItemIndex=ComboBox1->Items->IndexOfObject((TObject*)950);
  if(ComboBox1->ItemIndex<0)ComboBox1->ItemIndex=0;
  if(ComboBox2->ItemIndex<0)ComboBox2->ItemIndex=0;
  delete CodePageList;
  delete CodePageListSupported;
}
//---------------------------------------------------------------------------
// SANJYSAN http://delphi.ktop.com.tw/topic.asp?TOPIC_ID=55094
// UX
#define UNICODE 0
void* __fastcall TForm1::CodeConvert(void *str, int code_from, int code_to, int MAXLENG)
{
  PWSTR wszUnicode    = NULL; //Unicode
  PSTR  InStr         = NULL; //from Code
  PSTR  OutStr        = NULL; //to Code
  int   iLen          = 0;    //char length

  if (code_from!=UNICODE) // other to unicode
  {
    InStr = (char*)str;
    iLen = MultiByteToWideChar(code_from, 0, InStr, -1, NULL,0);
    wszUnicode = new wchar_t[MAXLENG+1];
    MultiByteToWideChar(code_from, 0, InStr, -1, wszUnicode,iLen);
    if (code_to==UNICODE) return wszUnicode;
  }
  else wszUnicode = (PWSTR)str;

  //unicode to other
  iLen = WideCharToMultiByte(code_to, 0, wszUnicode, -1, NULL,0,NULL, NULL);
  OutStr = new char[MAXLENG+1];
  WideCharToMultiByte(code_to, 0, wszUnicode, -1, OutStr,iLen,NULL, NULL);

  if (code_from!=UNICODE) delete [] wszUnicode;

  return OutStr;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  char *Output=NULL;
  char *Input=Memo1->Text.c_str();
  Output=(char*)CodeConvert(Input,
    (int)ComboBox1->Items->Objects[ComboBox1->ItemIndex],
    (int)ComboBox2->Items->Objects[ComboBox2->ItemIndex],
    Memo1->Text.Length()*2);
  Memo1->Text=AnsiString(Output);
  delete Output;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if(OpenDialog1->Execute())
    Memo1->Lines->LoadFromFile(OpenDialog1->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  if(SaveDialog1->Execute())
  {
    Memo1->Lines->SaveToFile(SaveDialog1->FileName);
    ShowMessage("File Saved");
  }
}
//---------------------------------------------------------------------------

